/* 
	Problem izdelovalec - odjemalec
	Zagotoviti je treba, da odjemalec pobira izdelke iz skladi"s"ca v enakem vrstnem redu kot jih 
	izdelovalec postavlja vanj. Izdelovalec ne sme dodajati izdelkov, "ce je skladi"s"ce polno, 
	odjemalec pa jih ne sme jemati, "ce je skladi"s"ce prazno. Vzemimo, da je v skladi"s"cu eno 
	samo mesto. 
   
	re"sitev s spremenljivko (id niti) in "cakanjem
	dodatno se uporablja flush, da ne more prihajati do te"zav zaradi 
	neusklajenosti predpomnilnikov in pomnilnika
*/

#include <stdio.h>
#include <omp.h> 

int skladisce;
int izdelek_pripravljen = 0;
  
void izdelovalec();
void odjemalec();

void main(void)  
{
	#pragma omp parallel sections
	{
		#pragma omp section
		izdelovalec();
		#pragma omp section
		odjemalec();
	}
}

void izdelovalec()
{
	int i = 0;

	printf("Proizvajalec\n");
	while (i < 50) 
	{
		i = i + 1;
		do {
			#pragma omp flush(izdelek_pripravljen)
		} while(izdelek_pripravljen==1);
		skladisce = i;
		#pragma omp flush(skladisce)
		izdelek_pripravljen = 1;
		#pragma omp flush(izdelek_pripravljen)
	}
}

void odjemalec()
{
	int i, v;

	printf("Porabnik\n");
	for (i = 0; i < 50; i++) 
	{
		do {
			#pragma omp flush(izdelek_pripravljen)
		} while(izdelek_pripravljen==0);
		#pragma omp flush(skladisce)
		v = skladisce;
		izdelek_pripravljen = 0;
		#pragma omp flush(izdelek_pripravljen)
		printf("Dobil: %d\n",v);
	}
}
